import argparse
import os

def parse_args():
    parser = argparse.ArgumentParser()
    parser.add_argument('--Q', type=int, default=10, help='Q')
    parser.add_argument('--iterations', type=int, default=10000, help='K')
    parser.add_argument('--etax', type=float, default=100, help='beta')
    parser.add_argument('--gamma', type=float, default=0.1, help='beta')
    parser.add_argument('--tau', type=float, default=0.1, help='beta')
    parser.add_argument('--etay', type=float, default=0.9, help='alpha')
    # parser.add_argument('--tau', type=float, default=0.001, help='alpha')
    parser.add_argument('--eta', type=float, default=0.5, help='used in memonent')
    parser.add_argument('--alpha', type=float, default=9, help='beta v')
    parser.add_argument('--beta', type=float, default=9, help='beta w')
    parser.add_argument('--name', default='mnist', help='The data name ')
    parser.add_argument('--num', default=1, type=int)
    parser.add_argument('--save_folder', type=str, default='', help='path to save result')
    parser.add_argument('--model_name', type=str, default='', help='Experiment name')
    parser.add_argument('--seed', type=int, default=3407)
    parser.add_argument('--gpu', type=int, default=3)
    parser.add_argument('--rw', type=float, default=1)
    parser.add_argument('--target', type=int, default=8)
    parser.add_argument('--full', type=int, default=101)
    parser.add_argument('--alg', type=str, default='DMLCBO', choices=['DMLCBO', 'Approx','RMD','VF', 'train'])
    args = parser.parse_args()


    if not args.save_folder:
        args.save_folder = './save_tb_results6/' + args.name

    args.model_name = '{}_{}_gamma_{}_tau_{}_eta_{}_etax_{}_etay_{}_Q_{}_iterations_{}_' \
                      '_alpha_{}_beta_{}_rw_{}'.format(args.alg, args.name,
                                                                            args.gamma,
                                                                            args.tau, args.eta, args.etax, args.etay,
                                                                            args.Q, args.iterations,
                                                                            args.alpha, args.beta, args.rw)
    args.save_folder = os.path.join(args.save_folder, args.model_name)

    return args



def parse_args2():
    parser = argparse.ArgumentParser()
    parser.add_argument('--Q', type=int, default=3, help='Q')
    parser.add_argument('--iterations', type=int, default=10000, help='K')
    parser.add_argument('--etax', type=float, default=1, help='etax')
    parser.add_argument('--etay', type=float, default=0.9, help='etay')
    parser.add_argument('--gamma', type=float, default=0.1, help='gamma')
    parser.add_argument('--tau', type=float, default=0.001, help='tau')
    parser.add_argument('--eta', type=float, default=1, help='used in memonent')
    parser.add_argument('--alpha', type=float, default=0.9, help='alpha')
    parser.add_argument('--beta', type=float, default=0.9, help='beta')
    parser.add_argument('--name', default='mnist', help='The data name ')
    parser.add_argument('--num', default=1, type=int)
    parser.add_argument('--save_folder', type=str, default='', help='path to save result')
    parser.add_argument('--model_name', type=str, default='', help='Experiment name')
    parser.add_argument('--seed', type=int, default=3407)
    parser.add_argument('--gpu', type=int, default=3)
    parser.add_argument('--rw', type=float, default=10)
    parser.add_argument('--target', type=int, default=8)
    parser.add_argument('--full', type=int, default=101)
    parser.add_argument('--alg', type=str, default='DMLCBO', choices=['DMLCBO', 'Approx','RMD','VF', 'train'])
    args = parser.parse_args()


    if not args.save_folder:
        args.save_folder = './save_tb_results5/' + args.name+'/'+str(args.target)

    args.model_name = '{}_{}_etax_{}_etay_{}_tau_{}_eta_{}_Q_{}_iterations_{}_' \
                      '_alpha_{}_beta_{}_rw_{}'.format(args.alg, args.name,
                                                                            args.etax,args.etay,
                                                                            args.tau, args.eta,
                                                                            args.Q, args.iterations,
                                                                            args.alpha, args.beta, args.rw)
    args.save_folder = os.path.join(args.save_folder, args.model_name)

    return args




def parse_args3():
    parser = argparse.ArgumentParser()
    parser.add_argument('--Q', type=int, default=3, help='Q')
    parser.add_argument('--iterations', type=int, default=10000, help='K')
    parser.add_argument('--epochs', type=int, default=100, help='epochs')
    parser.add_argument('--batch_size', type=int, default=60, help='batch_size')
    parser.add_argument('--etax', type=float, default=0.001, help='beta')
    parser.add_argument('--etay', type=float, default=0.9, help='alpha')
    parser.add_argument('--tau', type=float, default=0.01, help='alpha')
    parser.add_argument('--eta', type=float, default=1, help='used in memonent')
    parser.add_argument('--alpha', type=float, default=0.9, help='beta v')
    parser.add_argument('--beta', type=float, default=0.9, help='beta w')
    parser.add_argument('--name', default='cifar10', help='The data name ')
    parser.add_argument('--num', default=1, type=int)
    parser.add_argument('--save_folder', type=str, default='', help='path to save result')
    parser.add_argument('--model_name', type=str, default='', help='Experiment name')
    parser.add_argument('--seed', type=int, default=3407)
    parser.add_argument('--gpu', type=int, default=0)
    parser.add_argument('--rw', type=float, default=100)
    parser.add_argument('--target', type=int, default=8)
    parser.add_argument('--full', type=int, default=101)
    parser.add_argument('--cutout', action='store_true', default=False, help='use cutout')
    parser.add_argument('--cutout_length', type=int, default=16, help='cutout length')
    parser.add_argument('--init_channels', type=int, default=16, help='num of init channels')
    parser.add_argument('--train_portion', type=float, default=0.5, help='portion of training data')
    parser.add_argument('--layers', type=int, default=3, help='total number of layers')
    parser.add_argument('--alg', type=str, default='DMLCBO', choices=['DMLCBO', 'Approx','RMD','VF', 'train'])
    args = parser.parse_args()


    if not args.save_folder:
        args.save_folder = './save_tb_results1/' + args.name+'/'+str(args.target)

    args.model_name = '{}_{}_etax_{}_etay_{}_tau_{}_eta_{}_Q_{}_iterations_{}_' \
                      '_alpha_{}_beta_{}_rw_{}'.format(args.alg, args.name,
                                                                            args.etax,args.etay,
                                                                            args.tau, args.eta,
                                                                            args.Q, args.iterations,
                                                                            args.alpha, args.beta, args.rw)
    args.save_folder = os.path.join(args.save_folder, args.model_name)

    return args

